<template>
  <BasicModal v-bind="$attrs" :title="title" @register="registerInnerModal">
    <template #footer>
      <div v-if="isUpdate !== 3">
        <a-button type="default" @click="handleCancle">取消</a-button>
        <a-button type="primary" @click="handleSubmit">确认</a-button>
      </div>
    </template>
    <BasicForm @register="registerForm" />
  </BasicModal>
</template>

<script setup lang="ts">
import { BasicModal, useModalInner } from "@/components/Modal";
import { BasicForm, useForm } from "@/components/Form";
import { computed, ref, unref } from "vue";
import {
  factoryInfoInfo,
  factoryInfoAdd,
  factoryInfoUpdate,
} from "@/api/basicInfo/outputFactory";
import { modalSchemas } from "./factoryInfo.data";

defineOptions({ name: "FactoryInfoModal" });

const emit = defineEmits(["register", "reload"]);

const isUpdate = ref<number>(false);
const title = computed<string>(() => {
  return isUpdate.value == 1
    ? "编辑生产厂家基础信息;"
    : isUpdate.value == 2
    ? "新增生产厂家基础信息;"
    : "查看生产厂家基础信息;";
});

const [registerInnerModal, { modalLoading, closeModal }] = useModalInner(
  async (data: { record?: Recordable; update: number }) => {
    modalLoading(true);
    const { record, update } = data;
    isUpdate.value = update;
    if (isUpdate.value === 3) {
      setProps({ disabled: true });
    } else {
      setProps({ disabled: false });
    }
    if ((update === 1 || update === 3) && record) {
      const ret = await factoryInfoInfo(record.id);
      await setFieldsValue(ret);
    }
    modalLoading(false);
  }
);

const [registerForm, { setFieldsValue, resetForm, validate, setProps }] = useForm({
  labelWidth: 100,
  showActionButtonGroup: false,
  baseColProps: { span: 24 },
  schemas: modalSchemas,
});

async function handleSubmit() {
  try {
    modalLoading(true);
    const data = await validate();
    if (isUpdate.value === 1) {
      await factoryInfoUpdate(data);
    } else {
      await factoryInfoAdd(data);
    }
    emit("reload");
    closeModal();
    await resetForm();
  } catch (e) {
    console.warn(e);
  } finally {
    modalLoading(false);
  }
}
function handleCancle() {
  closeModal();
  resetForm();
}
</script>

<style scoped></style>
